package com.neusoft.smart.pos.inventory.persistent.domain;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class InventoryStoreHistoryExample {
    
    protected String orderByClause;
    
    protected boolean distinct;
    
    protected List<Criteria> oredCriteria;
    
    private Integer offset;
    
    private Integer limit;
    
    public InventoryStoreHistoryExample() {
        oredCriteria = new ArrayList<Criteria>();
    }
    
    public String getOrderByClause() {
        return orderByClause;
    }
    
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }
    
    public boolean isDistinct() {
        return distinct;
    }
    
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }
    
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }
    
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }
    
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }
    
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }
    
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }
    
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }
    
    public Integer getOffset() {
        return this.offset;
    }
    
    public void setOffset(Integer offset) {
        this.offset = offset;
    }
    
    public Integer getLimit() {
        return this.limit;
    }
    
    public void setLimit(Integer limit) {
        this.limit = limit;
    }
    
    public InventoryStoreHistoryExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }
    
    protected abstract static class GeneratedCriteria {
        
        protected List<Criterion> criteria;
        
        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }
        
        public boolean isValid() {
            return criteria.size() > 0;
        }
        
        public List<Criterion> getAllCriteria() {
            return criteria;
        }
        
        public List<Criterion> getCriteria() {
            return criteria;
        }
        
        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }
        
        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }
        
        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }
        
        public Criteria andIdIsNull() {
            addCriterion("isi.id is null");
            return (Criteria) this;
        }
        
        public Criteria andIdIsNotNull() {
            addCriterion("isi.id is not null");
            return (Criteria) this;
        }
        
        public Criteria andIdEqualTo(Integer value) {
            addCriterion("isi.id =", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("isi.id <>", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("isi.id >", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("isi.id >=", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdLessThan(Integer value) {
            addCriterion("isi.id <", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("isi.id <=", value, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdIn(List<Integer> values) {
            addCriterion("isi.id in", values, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("isi.id not in", values, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("isi.id between", value1, value2, "id");
            return (Criteria) this;
        }
        
        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("isi.id not between", value1, value2, "id");
            return (Criteria) this;
        }
        
        public Criteria andShopIdIsNull() {
            addCriterion("isi.shop_id is null");
            return (Criteria) this;
        }
        
        public Criteria andShopIdIsNotNull() {
            addCriterion("isi.shop_id is not null");
            return (Criteria) this;
        }
        
        public Criteria andShopIdEqualTo(Integer value) {
            addCriterion("isi.shop_id =", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdNotEqualTo(Integer value) {
            addCriterion("isi.shop_id <>", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdGreaterThan(Integer value) {
            addCriterion("isi.shop_id >", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("isi.shop_id >=", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdLessThan(Integer value) {
            addCriterion("isi.shop_id <", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdLessThanOrEqualTo(Integer value) {
            addCriterion("isi.shop_id <=", value, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdIn(List<Integer> values) {
            addCriterion("isi.shop_id in", values, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdNotIn(List<Integer> values) {
            addCriterion("isi.shop_id not in", values, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdBetween(Integer value1, Integer value2) {
            addCriterion("isi.shop_id between", value1, value2, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andShopIdNotBetween(Integer value1, Integer value2) {
            addCriterion("isi.shop_id not between", value1, value2, "shopId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdIsNull() {
            addCriterion("goods_id is null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdIsNotNull() {
            addCriterion("goods_id is not null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdEqualTo(Integer value) {
            addCriterion("goods_id =", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdNotEqualTo(Integer value) {
            addCriterion("goods_id <>", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdGreaterThan(Integer value) {
            addCriterion("goods_id >", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_id >=", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdLessThan(Integer value) {
            addCriterion("goods_id <", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdLessThanOrEqualTo(Integer value) {
            addCriterion("goods_id <=", value, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdIn(List<Integer> values) {
            addCriterion("goods_id in", values, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdNotIn(List<Integer> values) {
            addCriterion("goods_id not in", values, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdBetween(Integer value1, Integer value2) {
            addCriterion("goods_id between", value1, value2, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsIdNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_id not between", value1, value2, "goodsId");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeIsNull() {
            addCriterion("igi.bar_code is null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeIsNotNull() {
            addCriterion("igi.bar_code is not null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeEqualTo(String value) {
            addCriterion("igi.bar_code =", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeNotEqualTo(String value) {
            addCriterion("igi.bar_code <>", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeGreaterThan(String value) {
            addCriterion("igi.bar_code >", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeGreaterThanOrEqualTo(String value) {
            addCriterion("igi.bar_code >=", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeLessThan(String value) {
            addCriterion("igi.bar_code <", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeLessThanOrEqualTo(String value) {
            addCriterion("igi.bar_code <=", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeLike(String value) {
            addCriterion("igi.bar_code like", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeNotLike(String value) {
            addCriterion("igi.bar_code not like", value, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeIn(List<String> values) {
            addCriterion("igi.bar_code in", values, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeNotIn(List<String> values) {
            addCriterion("igi.bar_code not in", values, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeBetween(String value1, String value2) {
            addCriterion("igi.bar_code between", value1, value2, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsBarCodeNotBetween(String value1, String value2) {
            addCriterion("igi.bar_code not between", value1, value2, "goodsBarCode");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameIsNull() {
            addCriterion("igi.name is null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameIsNotNull() {
            addCriterion("igi.name is not null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameEqualTo(String value) {
            addCriterion("igi.name =", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameNotEqualTo(String value) {
            addCriterion("igi.name <>", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameGreaterThan(String value) {
            addCriterion("igi.name >", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameGreaterThanOrEqualTo(String value) {
            addCriterion("igi.name >=", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameLessThan(String value) {
            addCriterion("igi.name <", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameLessThanOrEqualTo(String value) {
            addCriterion("igi.name <=", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameLike(String value) {
            addCriterion("igi.name like", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameNotLike(String value) {
            addCriterion("igi.name not like", value, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameIn(List<String> values) {
            addCriterion("igi.name in", values, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameNotIn(List<String> values) {
            addCriterion("igi.name not in", values, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameBetween(String value1, String value2) {
            addCriterion("igi.name between", value1, value2, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsNameNotBetween(String value1, String value2) {
            addCriterion("igi.name not between", value1, value2, "goodsName");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryIsNull() {
            addCriterion("igi.cate_id is null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryIsNotNull() {
            addCriterion("igi.cate_id is not null");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryEqualTo(String value) {
            addCriterion("igi.cate_id =", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryNotEqualTo(String value) {
            addCriterion("igi.cate_id <>", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryGreaterThan(String value) {
            addCriterion("igi.cate_id >", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryGreaterThanOrEqualTo(String value) {
            addCriterion("igi.cate_id >=", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryLessThan(String value) {
            addCriterion("igi.cate_id <", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryLessThanOrEqualTo(String value) {
            addCriterion("igi.cate_id <=", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryLike(String value) {
            addCriterion("igi.cate_id like", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryNotLike(String value) {
            addCriterion("igi.cate_id not like", value, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryIn(List<String> values) {
            addCriterion("igi.cate_id in", values, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryNotIn(List<String> values) {
            addCriterion("igi.cate_id not in", values, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryBetween(String value1, String value2) {
            addCriterion("igi.cate_id between", value1, value2, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andGoodsCategoryNotBetween(String value1, String value2) {
            addCriterion("igi.cate_id not between", value1, value2, "goodsCategory");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumIsNull() {
            addCriterion("residue_num is null");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumIsNotNull() {
            addCriterion("residue_num is not null");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumEqualTo(BigDecimal value) {
            addCriterion("residue_num =", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumNotEqualTo(BigDecimal value) {
            addCriterion("residue_num <>", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumGreaterThan(BigDecimal value) {
            addCriterion("residue_num >", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("residue_num >=", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumLessThan(BigDecimal value) {
            addCriterion("residue_num <", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumLessThanOrEqualTo(BigDecimal value) {
            addCriterion("residue_num <=", value, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumIn(List<BigDecimal> values) {
            addCriterion("residue_num in", values, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumNotIn(List<BigDecimal> values) {
            addCriterion("residue_num not in", values, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("residue_num between", value1, value2, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andResidueNumNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("residue_num not between", value1, value2, "residueNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumIsNull() {
            addCriterion("var_num is null");
            return (Criteria) this;
        }
        
        public Criteria andVarNumIsNotNull() {
            addCriterion("var_num is not null");
            return (Criteria) this;
        }
        
        public Criteria andVarNumEqualTo(BigDecimal value) {
            addCriterion("var_num =", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumNotEqualTo(BigDecimal value) {
            addCriterion("var_num <>", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumGreaterThan(BigDecimal value) {
            addCriterion("var_num >", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("var_num >=", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumLessThan(BigDecimal value) {
            addCriterion("var_num <", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumLessThanOrEqualTo(BigDecimal value) {
            addCriterion("var_num <=", value, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumIn(List<BigDecimal> values) {
            addCriterion("var_num in", values, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumNotIn(List<BigDecimal> values) {
            addCriterion("var_num not in", values, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("var_num between", value1, value2, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andVarNumNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("var_num not between", value1, value2, "varNum");
            return (Criteria) this;
        }
        
        public Criteria andInPriceIsNull() {
            addCriterion("in_price is null");
            return (Criteria) this;
        }
        
        public Criteria andInPriceIsNotNull() {
            addCriterion("in_price is not null");
            return (Criteria) this;
        }
        
        public Criteria andInPriceEqualTo(BigDecimal value) {
            addCriterion("in_price =", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceNotEqualTo(BigDecimal value) {
            addCriterion("in_price <>", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceGreaterThan(BigDecimal value) {
            addCriterion("in_price >", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("in_price >=", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceLessThan(BigDecimal value) {
            addCriterion("in_price <", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("in_price <=", value, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceIn(List<BigDecimal> values) {
            addCriterion("in_price in", values, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceNotIn(List<BigDecimal> values) {
            addCriterion("in_price not in", values, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("in_price between", value1, value2, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andInPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("in_price not between", value1, value2, "inPrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceIsNull() {
            addCriterion("sale_price is null");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceIsNotNull() {
            addCriterion("sale_price is not null");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceEqualTo(BigDecimal value) {
            addCriterion("sale_price =", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceNotEqualTo(BigDecimal value) {
            addCriterion("sale_price <>", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceGreaterThan(BigDecimal value) {
            addCriterion("sale_price >", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sale_price >=", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceLessThan(BigDecimal value) {
            addCriterion("sale_price <", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sale_price <=", value, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceIn(List<BigDecimal> values) {
            addCriterion("sale_price in", values, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceNotIn(List<BigDecimal> values) {
            addCriterion("sale_price not in", values, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sale_price between", value1, value2, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andSalePriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sale_price not between", value1, value2, "salePrice");
            return (Criteria) this;
        }
        
        public Criteria andActionDireIsNull() {
            addCriterion("action_dire is null");
            return (Criteria) this;
        }
        
        public Criteria andActionDireIsNotNull() {
            addCriterion("action_dire is not null");
            return (Criteria) this;
        }
        
        public Criteria andActionDireEqualTo(Integer value) {
            addCriterion("action_dire =", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireNotEqualTo(Integer value) {
            addCriterion("action_dire <>", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireGreaterThan(Integer value) {
            addCriterion("action_dire >", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireGreaterThanOrEqualTo(Integer value) {
            addCriterion("action_dire >=", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireLessThan(Integer value) {
            addCriterion("action_dire <", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireLessThanOrEqualTo(Integer value) {
            addCriterion("action_dire <=", value, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireIn(List<Integer> values) {
            addCriterion("action_dire in", values, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireNotIn(List<Integer> values) {
            addCriterion("action_dire not in", values, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireBetween(Integer value1, Integer value2) {
            addCriterion("action_dire between", value1, value2, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionDireNotBetween(Integer value1, Integer value2) {
            addCriterion("action_dire not between", value1, value2, "actionDire");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeIsNull() {
            addCriterion("action_type is null");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeIsNotNull() {
            addCriterion("action_type is not null");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeEqualTo(String value) {
            addCriterion("action_type =", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeNotEqualTo(String value) {
            addCriterion("action_type <>", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeGreaterThan(String value) {
            addCriterion("action_type >", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeGreaterThanOrEqualTo(String value) {
            addCriterion("action_type >=", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeLessThan(String value) {
            addCriterion("action_type <", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeLessThanOrEqualTo(String value) {
            addCriterion("action_type <=", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeLike(String value) {
            addCriterion("action_type like", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeNotLike(String value) {
            addCriterion("action_type not like", value, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeIn(List<String> values) {
            addCriterion("action_type in", values, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeNotIn(List<String> values) {
            addCriterion("action_type not in", values, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeBetween(String value1, String value2) {
            addCriterion("action_type between", value1, value2, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andActionTypeNotBetween(String value1, String value2) {
            addCriterion("action_type not between", value1, value2, "actionType");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeIsNull() {
            addCriterion("isi.created_time is null");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeIsNotNull() {
            addCriterion("isi.created_time is not null");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeEqualTo(Date value) {
            addCriterion("isi.created_time =", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeNotEqualTo(Date value) {
            addCriterion("isi.created_time <>", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeGreaterThan(Date value) {
            addCriterion("isi.created_time >", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("isi.created_time >=", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeLessThan(Date value) {
            addCriterion("isi.created_time <", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeLessThanOrEqualTo(Date value) {
            addCriterion("isi.created_time <=", value, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeIn(List<Date> values) {
            addCriterion("isi.created_time in", values, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeNotIn(List<Date> values) {
            addCriterion("isi.created_time not in", values, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeBetween(Date value1, Date value2) {
            addCriterion("isi.created_time between", value1, value2, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedTimeNotBetween(Date value1, Date value2) {
            addCriterion("isi.created_time not between", value1, value2, "createdTime");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByIsNull() {
            addCriterion("isi.created_by is null");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByIsNotNull() {
            addCriterion("isi.created_by is not null");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("isi.created_by =", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("isi.created_by <>", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("isi.created_by >", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("isi.created_by >=", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByLessThan(String value) {
            addCriterion("isi.created_by <", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("isi.created_by <=", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByLike(String value) {
            addCriterion("isi.created_by like", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByNotLike(String value) {
            addCriterion("isi.created_by not like", value, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("isi.created_by in", values, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("isi.created_by not in", values, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("isi.created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }
        
        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("isi.created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }
    }
    
    public static class Criteria extends GeneratedCriteria {
        
        protected Criteria() {
            super();
        }
    }
    
    public static class Criterion {
        
        private String condition;
        
        private Object value;
        
        private Object secondValue;
        
        private boolean noValue;
        
        private boolean singleValue;
        
        private boolean betweenValue;
        
        private boolean listValue;
        
        private String typeHandler;
        
        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }
        
        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }
        
        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }
        
        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }
        
        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
        
        public String getCondition() {
            return condition;
        }
        
        public Object getValue() {
            return value;
        }
        
        public Object getSecondValue() {
            return secondValue;
        }
        
        public boolean isNoValue() {
            return noValue;
        }
        
        public boolean isSingleValue() {
            return singleValue;
        }
        
        public boolean isBetweenValue() {
            return betweenValue;
        }
        
        public boolean isListValue() {
            return listValue;
        }
        
        public String getTypeHandler() {
            return typeHandler;
        }
    }
}
